'''
    enitty module
    
    base class for all game objects
'''

import pygame
import data

UP = 1
LEFT = 2
DOWN = 3
RIGHT = 4

class entity(pygame.sprite.Sprite):
    """entity class"""
    def __init__(self, pos, image, camerax):
        pygame.sprite.Sprite.__init__(self)
        self.image = data.loadimage(image)
        self.image.set_colorkey((0,0,0))
        self.rect = self.image.get_rect()
        self.rect.left = pos[0] - camerax
        self.rect.bottom = pos[1]
        self.pos = self.image.get_rect()
        self.pos.left = pos[0]
        self.pos.bottom = pos[1]
        self.hvelocity = 2
        self.jumpvel = -4
        self.fallvel = 3
        self.jumpcycles = 0
        self.jumping = False
        self.falling = False
        self.airborne = False
        self.direction = LEFT 
        self.health = 100
        
    def moveRight(self, moveOnScreen):
        if moveOnScreen:
            self.rect.move_ip(self.hvelocity, 0)
        self.pos.left += self.hvelocity
        self.direction = RIGHT
        
    def moveLeft(self, moveOnScreen):
        if moveOnScreen:
            self.rect.move_ip(-self.hvelocity, 0)
        self.pos.left -= self.hvelocity
        self.direction = LEFT
        
    def ground(self):
        if self.falling and self.airborne:
            self.falling = False
            self.airborne = False
            offset = (self.rect.bottom - 1 + self.fallvel) % 32
            self.rect.bottom = (self.rect.bottom - 1 + self.fallvel) - offset
            self.pos.bottom = self.rect.bottom
    def jump(self):
        if not self.jumping and not self.falling:
            self.jumping = True
            self.airborne = True
            self.jumpcycles = 0
            
    def fall(self):
        if not self.jumping:
            self.falling = True
            self.airborne = True
            
    def hitFall(self):
        self.falling = True
        self.jumping = False
        offset = 32 - ((self.rect.top + self.jumpvel) % 32)
        if offset < 32:
            self.rect.top = (self.rect.top + self.jumpvel) + offset    
            self.pos.top = self.rect.top
        
    def update(self):
        if self.jumping:
            if self.jumpcycles >= 18:
                self.falling = True
                self.jumping = False
            else:
                self.jumpcycles += 1
                self.rect.move_ip(0, self.jumpvel)
                self.pos.top += self.jumpvel
        elif self.falling:
            self.rect.move_ip(0, self.fallvel)
            self.pos.top += self.fallvel  
            
        if self.rect.bottom >= 480:
            self.kill()
            self.health = 0