'''
    Input handler class

    pstore the input generically 
    to allow the game module to handle processing
'''

from pygame.locals import *
class input:
    """Input handler class"""
    def __init__(self):
        
        self.inputstate = {'right': False, 'left':False, 'up':False, 'down':False, 'pause':False, 'attack':False,'project':False, 'pos':(0,0)}
        
    def getState(self):
        return self.inputstate
    
    def processKeyDown(self, event):
        if event.key == K_RIGHT or event.key == K_d:
            self.inputstate['right'] = True
        if event.key == K_LEFT or event.key == K_a:
            self.inputstate['left'] = True
        if event.key == K_UP or event.key == K_w:
            self.inputstate['up'] = True
        if event.key == K_DOWN or event.key == K_s:
            self.inputstate['down'] = True
        if event.key == K_ESCAPE or event.key == K_p:
            self.inputstate['pause'] = True
            
    def processKeyUp(self, event):
        if event.key == K_RIGHT or event.key == K_d:
            self.inputstate['right'] = False
        if event.key == K_LEFT or event.key == K_a:
            self.inputstate['left'] = False
        if event.key == K_UP or event.key == K_w:
            self.inputstate['up'] = False
        if event.key == K_DOWN or event.key == K_s:
            self.inputstate['down'] = False
        if event.key == K_ESCAPE or event.key == K_p:
            self.inputstate['pause'] = False
            
    def mouseDown(self, event):
        if event.button == 1:
            self.inputstate['attack'] = True
            self.inputstate['pos'] = event.pos
        if event.button == 3:
            self.inputstate['project'] = True
            
    def mouseUp(self, event):
        if event.button == 1:
            self.inputstate['attack'] = False
        if event.button == 3:
            self.inputstate['project'] = False
        