import pygame
import data
import random
import vector

UP = 1
LEFT = 2
DOWN = 3
RIGHT = 4
UPLEFT = 5
UPRIGHT = 6
DOWNLEFT = 7
DOWNRIGHT = 8
STILL = 9

class soul(pygame.sprite.Sprite):
    def __init__(self, group, level):
        pygame.sprite.Sprite.__init__(self)
        self.image = data.loadimage('soul')
        self.image.set_colorkey(pygame.Color(0,0,0))
        r = random.randint(0, 255)
        g = random.randint(0, 255)
        b = random.randint(0, 255)
        for x in xrange(self.image.get_width()):
            for y in xrange(self.image.get_height()):
                if self.image.get_at((x, y)) == (255, 255, 255, 255):
                    self.image.set_at((x, y), (r, g, b))
        self.rect = self.image.get_rect()
        self.rect.left = random.randint(0, 608)
        self.rect.top = random.randint(0, 448)
        self.pos = self.image.get_rect()
        self.pos.left = 0
        self.pos.top = 0
        self.group = group
        self.group.add(self)
        self.direction = dir
        self.velocity = 1
        self.vector = vector.vec2d((self.rect.centerx, self.rect.centery))
        self.lastThink = 0
        self.thinkSpeed = 1000
        level.aliveSouls += 1
        self.level = level
        
    def update(self, camerax, elapsed, player):
        
        self.lastThink += elapsed
        if self.lastThink > self.thinkSpeed:
            self.think(player)
        
        if self.direction == DOWNRIGHT:
            self.rect.left += self.velocity
            self.rect.top += self.velocity
            if self.rect.right > 640:
                self.rect.right = 640
            if self.rect.bottom > 480:
                self.rect.bottom = 480
        
        elif self.direction == UPRIGHT:
            self.rect.left += self.velocity
            self.rect.top -= self.velocity
            if self.rect.right > 640:
                self.rect.right = 640
            if self.rect.top < 0:
                self.rect.top = 0
                
        elif self.direction == DOWNLEFT:
            self.rect.left -= self.velocity
            self.rect.top += self.velocity
            if self.rect.left < 0:
                self.rect.left = 0
            if self.rect.bottom > 480:
                self.rect.bottom = 0
                
        elif self.direction == UPLEFT:
            self.rect.left -= self.velocity
            self.rect.top -= self.velocity
            if self.rect.left < 0:
                self.rect.left = 0
            if self.rect.top < 0:
                self.rect.top = 0
                        
        self.vector.x = self.rect.centerx
        self.vector.y = self.rect.centery
        
    def think(self, player):
        mid = player.projection.midPoint()
        
        if mid[0] > self.rect.centerx:
            if mid[1] > self.rect.centery:
                self.direction = DOWNRIGHT
            else:
                self.direction = UPRIGHT
        else:
            if mid[1] > self.rect.centery:
                self.direction = DOWNLEFT
            else:
                self.direction = UPLEFT
                
        self.lastThink = 0
        
    def kill(self):
        pygame.sprite.Sprite.kill(self)
        print self.level.aliveSouls
        self.level.aliveSouls -= 1